//+------------------------------------------------------------------+
//|                                                   Nina_EMA_1.mq4 |
//+------------------------------------------------------------------+
#property indicator_chart_window

#property indicator_buffers 3
#property indicator_color1 Blue
#property indicator_color2 Red
#property indicator_color3 Aqua

extern bool alert_ON=true; //ON=true,OFF=false
extern int EMA_period=50;
extern int EMA_method=0;   //0=Close, 1=Open, 2=High, 3=Low, 4=median,5=typical, 6=weighted close

//---- buffers
double Buffer_long[];
double Buffer_short[];
double EMA50[];

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   IndicatorBuffers(3);

   SetIndexStyle(0,DRAW_ARROW,STYLE_SOLID,1);
   SetIndexArrow(0,233);
   SetIndexBuffer(0,Buffer_long);
   SetIndexEmptyValue(0,0.0);
   
   SetIndexStyle(1,DRAW_ARROW,STYLE_SOLID,1);
   SetIndexArrow(1,234);
   SetIndexBuffer(1,Buffer_short);
   SetIndexEmptyValue(1,0.0);
   
   SetIndexStyle(2,DRAW_LINE);
   SetIndexLabel(2,"EMA50");
   SetIndexBuffer(2,EMA50);
   SetIndexStyle(2,DRAW_LINE);
   SetIndexEmptyValue(2,0.0);
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int i;
   static bool turn_alarm = true; // for each candle, only alarm at the begin
   int    counted_bars=IndicatorCounted();
//----check for possible errors
   if(counted_bars<0) return(-1);
//----last counted bar will be recounted
   int limit=Bars-counted_bars;
   if(counted_bars<1) { // first time, buffers initialized
      for(i=limit; i>=0; i--){
         Buffer_long[i]=0;
         Buffer_short[i]=0;
      }
   }   
   else {
      limit++;
   }
//variables
   int position_ind0=0, position_ind1=0;
   // position_ind0 = -1, below
   //               =  1, up
//Main loop
   for(i=limit; i>=0; i--){
      EMA50[i]=iMA(NULL,0,EMA_period,0,MODE_EMA,EMA_method,i);
//Cross up check
// position_ind0 is the old one, and position_ind1 is the new one
      position_ind0 = position_ind1;
      if(Open[i]>EMA50[i]) {
          position_ind1=1;
      }
      else {
          position_ind1=-1;
      }
      if(i != limit) { // don't update buffers at limit
         if((position_ind0==-1) && (position_ind1==1)) {  // cross up
            Buffer_long[i]=Low[i]-iATR(NULL,0,5,i)/2;
         }
         if((position_ind0==1) && (position_ind1==-1)) {  // cross down
            Buffer_short[i]=High[i]+iATR(NULL,0,5,i)/2;
         }
      }
   }
   // for the current crossing, make the sound
   // still have some problem for the mechanism, leave it for future modification
	if(Volume[0]>1) return(0);
	// for the current crossing, make the sound
	// still have problem for this mechanism, leave it for later modification	   
	if(alert_ON) {   
      if(position_ind0*position_ind1<0) {  // time for alarm
         PlaySound("clock-alarm2.wav");
         turn_alarm=false;
      }
   }
//----
   return(0);
   }
//+------------------------------------------------------------------+